local qrencode;


local whurl=true;
local playerLinkPending=false;
local playerName;
local playerRealm;
local playerLink;

function reinit()
	for y=1,40 do
			for x=1,40 do
				_G["qr"..(x).."_"..(y)]:SetAlpha(0);
			end
		end
end

function init(event,arg1)
		WQR_VARS={};
		for y=1,40 do
			for x=1,40 do
				local f=CreateFrame("Frame","qr"..x.."_"..y,QR.viewFrame.dotHolder);
				f:SetFrameStrata("DIALOG");
				f:SetWidth(4);
				f:SetHeight(4);
				f:SetParent(QR.viewFrame.dotHolder);
				f.texture = f:CreateTexture();
				f.texture:SetAllPoints(f);
				f.texture:SetTexture(0,0,0);
				f:SetPoint("CENTER",-78+((y-1)*4),-78+((x-1)*4));
				f:Show();
				f:SetAlpha(0);
			end
		end
		QR.viewFrame:Show();
		local origChatFrame_OnHyperlinkShow = ChatFrame_OnHyperlinkShow; -- (1)
		ChatFrame_OnHyperlinkShow = function(...) -- (2)
   		local chatFrame, link, text, button = ...; -- (3)
   		local n=nil;
   		local s=nil;
   		n,s=string.match(link,'player:([^\-]+)\-([^:]+)');
   		
   		if (s==nil)then
   			n = string.match(link,'player:([^:]+)');
   			s = GetRealmName();
   			playerLink=n;
   		else
   			playerLink=n.."\-"..s;
   		end
   		if(n~=nil and s~=nil)then
   			playerLinkPending=true;
   			playerName=n;
   			playerRealm=s;
   		end
      return origChatFrame_OnHyperlinkShow(...);
   end
end

local function qrgen(str)
	reinit();
	a,t=QR:qrcode(str);
	QR.viewFrame:SetWidth((#t*4)+16)
	QR.viewFrame:SetHeight((#t*4)+16)
	local mod = math.floor((40-(#t))/2)
	if(math.fmod(#t,2)~=0)then
		QR.viewFrame.dotHolder:SetPoint("CENTER",2,2);
	else
		QR.viewFrame.dotHolder:SetPoint("CENTER",0,0);
	end
	for y=1,#t do
		for x=1,#t[1] do

			local viewFrame = QR.viewFrame;
			if(t[y][x] < 0)then
				_G["qr"..(x+mod).."_"..(y+mod)]:SetAlpha(0);
				--_G["qr"..x.."_"..y]:SetPoint("BOTTOMLEFT",4+(y*4),8+((#t-x)*4));
			else
				_G["qr"..(x+mod).."_"..(y+mod)]:SetAlpha(1);
				--_G["qr"..x.."_"..y]:SetPoint("BOTTOMLEFT",4+(y*4),8+((#t-x)*4));
			end
		end
	end
end

local function initQR()
	
		
end

SLASH_QRTEST1 = '/qr';
SLASH_QRTARGET1 = '/qrtar';
local function handler(msg, editbox)
	print("Generating QR code for "..msg);
	local t,id=string.match(msg:sub(13),'([a-z]+):([0-9]+)');
	--local n,s=string.match(msg,'(.+?)\-(.+?)');
	if(t~=nil and id~=nil)then
		playerLinkPending=false;
		initQR();
		viewFrame:Show();
		if(t=='enchant' or t=='spell')then
			if(whurl==true)then
				qrgen('www.wowhead.com/spell='..id);
			else
				qrgen('SPELL:'..id);
			end
		elseif(t=='achievement')then
		if(whurl==true)then
				qrgen('www.wowhead.com/achievement='..id);
			else
			qrgen('ACHIEVEMENT:'..id);
			end
		elseif(t=='quest')then
		if(whurl==true)then
				qrgen('www.wowhead.com/quest='..id);
			else
			qrgen('QUEST:'..id);
			end
		elseif(t=='currency')then
		if(whurl==true)then
				qrgen('www.wowhead.com/currency='..id);
			else
			qrgen('CURRENCY:'..id);
			end
		elseif(t=='item')then
		if(whurl==true)then
				qrgen('www.wowhead.com/item='..id);
			else
				qrgen('ITEM:'..id);
			end
		elseif(t=='battlepet')then
			local guid=string.match(msg,':(BattlePet-[0-9]-[^\|]+)\|h');
			speciesID, customName, level, xp, maxXp, displayID, isFavorite, petName, petIcon, petType, creatureID, sourceText, description, isWild, canBattle, tradable, unique = C_PetJournal.GetPetInfoByPetID(guid);
			if(whurl==true)then
				qrgen('www.wowhead.com/npc='..creatureID)
			else
				qrgen('NPC:'..creatureID)
			end
		else
			viewFrame:Hide();
			print("This link is not implemented yet");
		end
	elseif (playerLinkPending == true and msg==playerLink and msg~=nil)then
		initQR();
		viewFrame:Show();
		qrgen('http://us.battle.net/wow/en/character/'..playerRealm..'/'..playerName..'/advanced');
	else
		
		msg=string.gsub(msg,' ','+');
		initQR();
		viewFrame:Show();
		if(whurl==true)then
			qrgen('www.wowhead.com/search='..msg);
		else
			qrgen('SEARCH:'..msg);
		end
		playerLinkPending=false;
	end
end

local function handlerb(msg, editbox)

	initQR();
	if(UnitIsPlayer("target")== 1)then
		local name,realm = UnitName("target");
		if(realm == nil)then
			realm = GetRealmName();
		end
		viewFrame:Show();
		qrgen('http://us.battle.net/wow/en/character/'..realm..'/'..name..'/advanced');
	else
		local guid, name = UnitGUID("target"), UnitName("target"); 
		local guidCol={};
		for word in string.gmatch(guid, '([^-]+)') do
    	table.insert(guidCol,word);
		end
		local id=guidCol[(#guidCol-1)];
		local tartype=guidCol[1];
		if(tartype=="Creature" or tartype=="Vehicle" or tartype=="Pet")then
			QR.viewFrame:Show();
			if(whurl==true)then
				qrgen('www.wowhead.com/npc='..id)
			else
				qrgen('NPC:'..id)
			end
		end
	end
end

SlashCmdList["QRTEST"] = handler;
SlashCmdList["QRTARGET"] = handlerb;